.TH Xnp2 1 "17 Nov 2003"
.SH NAME
Xnp2 \- PC-9801 series emulator
.SH SYNOPSIS
.B xnp2
[
.B \--config filename
]
[
.B \--timidity-config filename
]
[
.B FD1 image
[
.B FD2 image
[
.B FD3 image
[
.B FD4 image
]
]
]
]
.SH DESCRIPTION
.B PC-9801 series emulator for UNIX platform.
.SH OPTIONS
.TP
.B \--config
Indicate Xnp2 configuration file.
[Default: $(HOME)/.np2/np2rc]
.TP
.B \--timidity-config
Indicate Xnp2 included software MIDI configuration file.
[Default: $(HOME)/.np2/timidity.cfg]
.SH EXAMPLES
.nf
Indicate Xnp2 configuration file "np2.cfg".
.ft B
xnp2 --config np2.cfg
.ft R

Indicate software MIDI configuration file "/usr/local/lib/timidity/timidity.cfg".
.ft B
xnp2 --timidity-config /usr/local/lib/timidity/timidity.cfg
.ft R

Insert system.d88 disk image in floppy disk drive1, insert data.d88 disk image in floopy disk drive2. And Xnp2 is started.
.ft B
xnp2 system.d88 data.d88
.ft R
.fi
.SH COMMAND
.TP
.B Mouse middle button
Change mouse operation between X and Xnp2.
.SH FILES
.TP
.B $(HOME)/.np2/np2rc
Xnp2 configuration file
.TP
.B $(HOME)/.np2/font.tmp
font bitmap file
.TP
.B $(HOME)/.np2/bios.rom
BIOS ROM file
.TP
.B $(HOME)/.np2/font.rom
font ROM file
.TP
.B $(HOME)/.np2/sound.rom
sound BIOS ROM file
.TP
.B $(HOME)/.np2/timidity.cfg
included software MIDI configuration file
.TP
.B $(HOME)/.np2/2608_bd.wav
OPNA rythm sound source (bass drum)
.TP
.B $(HOME)/.np2/2608_sd.wav
OPNA rythm sound source (snare drum)
.TP
.B $(HOME)/.np2/2608_top.wav
OPNA rythm sound source (Cymbal)
.TP
.B $(HOME)/.np2/2608_hh.wav
OPNA rythm sound source (High hat)
.TP
.B $(HOME)/.np2/2608_tom.wav
OPNA rythm sound source (Tamm)
.TP
.B $(HOME)/.np2/2608_rim.wav
OPNA rythm sound source (Rim shor)
.TP
.B /usr/X11R6/lib/X11/xnp2/np2tool.d88
disk image for hostdrv.
.TP
.B /usr/X11R6/lib/X11/xnp2/fddseek.wav
floppy disk seek sound file
.TP
.B /usr/X11R6/lib/X11/xnp2/fddseek1.wav
another floppy disk seek sound file
.SH AUTHOR
Yui <np2@yui.ne.jp>, is
.B Neko Project II
main developer, who is maintained for MS-Windows, MacOS 8.x and MacOS 9 version.
.br
NONAKA Kimihiro <aw9k-nnk@asahi-net.or.jp>, he is ported
.B Neko Project II
for UNIX platform.
.br
tk800 <tk_np2x@yahoo.co.jp>, is ported
.B Neko Project II
for MacOS X.
.SH "SEE ALSO"
.B Xnp2
Web site: http://www.asahi-net.or.jp/~aw9k-nnk/np2/ (japanese)
